#include <asm/io.h>
#include <stdio.h>


#include "poke.h"
#include "iodvp.h"

extern PX2070Ports *S_pCurrentDVPPorts;

#ifndef __XR__
int drawpic(char *path,int X ,int Y)
{
int i,j;
FILE *input;
unsigned char image[480][640];

printf("1\n");
if ( (input=fopen(path,"rb")) == NULL)
{
return(0);
}

printf("2\n");
fread(image,X*Y,1,input);

vga_setcolor(0);

printf("3\n");
for(i=0;i<480;i++)
  for(j=0;j<640;j++)
  {
  if((image[i][j]) == 0)
    {
    vga_setcolor(0);
    vga_drawpixel(j,i);
    }
  else
    {
     vga_setcolor(7);
     vga_drawpixel(j,i);
    }
  }


}
void graphicson(void)
{
int x=0,
    y=0;                           /* pixels */
if( vga_hasmode(20) )               /* modes defined in vga.h */
        vga_setmode(20);
else
  {
  printf("video mode not available.\n");
  exit(-1);
  }
  vga_setcolor(7);         /* no clue where the colors are set */
                             /* 320 is pink from my experiments */

for(x=0; x <= 640 ; x++)            /* draw a box on the screen */
{
  for(y=0; y <= 480 ; y++)
  {
  vga_drawpixel(x,y);
  }
}
}
#endif

void vga_on(void)
{
	outw(6,Gi);
	outw((inw(Gd)&0xfbff)|0x400,Gd);
	return;	
}

void set_1085_ports(p0)
unsigned short p0;
{
	outw(7,Gi);
	tmp=p0<<5;
	tmp&=0xfff<<5;
	printf("0x%x 1085 base\n",tmp>>5);
	outw(tmp,Gd);
	printf("Verify: 0x%x\n",inw(Gd)>>5);
	return;
}

void set_1070_ports(p0,p1,p2,p3,p4)
unsigned short p0,p1,p2,p3,p4;
{
	/* Setup the 12bit base io addresses for each port */
	outw(0,Gi); outw(p0,Gd);
	outw(1,Gi); outw(p1,Gd);
	outw(2,Gi); outw(p2,Gd);
	outw(3,Gi); outw(p3,Gd);
	outw(4,Gi); outw(p4,Gd);
	set_MISC_base((p0&0xf000 >> 12));
	return;
}

void set_MISC_base(unsigned short v)
{
	outw(6,Gi);
	tmp  = inw(Gd)&(0xffff-MISC_BLOCK);
	tmp |= (v&0xf)<<3;
	tmp  = tmp&0xffff;
	outw(6,Gi);
	outw(tmp,Gd);
	return;
}

void Show_Gate(void)
{
	char a;
	unsigned short v;


	printf("\n   0      1      2      3      4  "
		"1070 Port Address Registers\n");
	for(;a<5;a++) printf("0x%04x ",loc_DVP(a));
	printf("\n  I2C    MISC  1085 base\n");
	for(;a<7;a++)
	{
		outw(a,Gi);
		printf("0x%04x ",inw(Gd));
	}
	outw(7,Gi);
	printf("0x%04x ",(inw(Gd)&(0xfff<<5))>>5);
	printf("\n     0      1      2      3      4      5      6      7      8 Status Registers\n");
	for(;a<16;a++)
	{
		outw(a,Gi);
		printf("0x%4x ",inw(Gd));
	}
	printf("\n");
	return;
}

void show_1070(void)
{
	printf("0x760 = 0x%x\n",inw(0x760));
}
