#ifndef FD_remote2_h_
#define FD_remote2_h_
/* Header file generated with fdesign. */

/** Callback routines and free object handlers **/

extern void call_keypad(FL_OBJECT *, long);
extern void call_mute(FL_OBJECT *, long);
extern void call_style(FL_OBJECT *, long);
extern void call_settings(FL_OBJECT *, long);
extern void call_power(FL_OBJECT *, long);
extern void call_xtimer(FL_OBJECT *, long);
extern void call_capture(FL_OBJECT *, long);
extern void call_freeze(FL_OBJECT *, long);
extern void call_help(FL_OBJECT *, long);
extern void call_volume_up(FL_OBJECT *, long);
extern void call_volume_down(FL_OBJECT *, long);
extern void call_channel_up(FL_OBJECT *, long);
extern void call_channel_down(FL_OBJECT *, long);


/**** Forms and Objects ****/

typedef struct {
	FL_FORM *remote2;
	void *vdata;
	char *cdata;
	long  ldata;
	FL_OBJECT *but_1;
	FL_OBJECT *but_2;
	FL_OBJECT *but_3;
	FL_OBJECT *but_4;
	FL_OBJECT *but_7;
	FL_OBJECT *but_5;
	FL_OBJECT *but_8;
	FL_OBJECT *but_6;
	FL_OBJECT *but_9;
	FL_OBJECT *but_0;
	FL_OBJECT *but_mute;
	FL_OBJECT *but_style;
	FL_OBJECT *but_settings;
	FL_OBJECT *channel_text;
	FL_OBJECT *volume_text;
	FL_OBJECT *power;
	FL_OBJECT *xtimer;
	FL_OBJECT *but_capture;
	FL_OBJECT *but_freeze;
	FL_OBJECT *but_help;
	FL_OBJECT *volume_up;
	FL_OBJECT *volume_down;
	FL_OBJECT *channel_up;
	FL_OBJECT *channel_down;
} FD_remote2;

extern FD_remote2 * create_form_remote2(void);

#endif /* FD_remote2_h_ */
