#include <asm/io.h>
#include <stdio.h>
#include <errno.h>

#include "xr.h"
#include "remote.h"
#include "tv_image.h"

int main(int argc,char *argv[])
{
	FL_OBJECT * object;

	fl_initialize(&argc, argv, "X-Remote", 0, 0); 

	/* set this to 0 for testing w/o toughing card */
	card_present = 1;

	/* io permissions */
	if (iopl(3))
	{
		fprintf(stderr,"Error for IO Permissions");
		exit(-1);
	}

	remote_setup();

	if ( card_present )
		tv_setup();

	tv_win = tv_create_win();
	
	if ( card_present )
	{
		tv_set_image_to_window( tv_win );

		iCurrentVolume = 75;
		set_volume();
		iCurrentChannel = iMinChannel;
		set_channel();
	}

	do
	{
		object=fl_do_forms();
	}
	while(object != form0->power);

	return(0);
}
